; Source created with Parsic Version 3.x

; at              : 17/08/02 14.04.41


; Project File    : c:\PROGRA~1\PARSIC\EEPROM\EEPROG1.PIC

; Project Version : 1.0.23

; Created         : 25/06/02 9.41.00

; Last change     : 17/08/02 14.04.34

	PROCESSOR 16F876

	INCLUDE P16F876.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_ON & _BODEN_ON & _XT_OSC & _LVP_OFF & _CPD_OFF & _DEBUG_OFF

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

DATA1	= 32	; located in Bank 0
DATA1_HI	= 33	; located in Bank 0
DATA2	= 34	; located in Bank 0
DATA2_HI	= 35	; located in Bank 0
DATA3	= 36	; located in Bank 0
DATA3_HI	= 37	; located in Bank 0
ZR2	= 38	; located in Bank 0
ZR2_FD	= 39	; located in Bank 0
EE1_FD	= 40	; located in Bank 0
ZR1	= 41	; located in Bank 0
ZR1_FD	= 42	; located in Bank 0
S0	= 43	; located in Bank 0
MF1	= 44	; located in Bank 0
MF1_HI	= 45	; located in Bank 0
MF2	= 46	; located in Bank 0
MF2_HI	= 47	; located in Bank 0
MF2_FD	= 48	; located in Bank 0
TR1	= 49	; located in Bank 0
TR1_HI	= 50	; located in Bank 0
LT1_FD	= 51	; located in Bank 0
LT2_FD	= 52	; located in Bank 0
LT3_FD	= 53	; located in Bank 0
LT4_FD	= 54	; located in Bank 0
RAM	= 55	; located in Bank 0
SYS_TMP1	= 115	; located in Bank 0, 1, 2, 3
SYS_TMP2	= 116	; located in Bank 0, 1, 2, 3
SYS_WSAV	= 117	; located in Bank 0, 1, 2, 3
SYS_SSAV	= 118	; located in Bank 0, 1, 2, 3
SYS_PSAV	= 119	; located in Bank 0, 1, 2, 3
SYS_TMP3	= 120	; located in Bank 0, 1, 2, 3
SYS_TMP4	= 121	; located in Bank 0, 1, 2, 3
SYS_TMP5	= 122	; located in Bank 0, 1, 2, 3
SYS_TMP6	= 123	; located in Bank 0, 1, 2, 3
SYS_TMP9	= 124	; located in Bank 0, 1, 2, 3
SYS_TMP10	= 125	; located in Bank 0, 1, 2, 3

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	MOVLW HIGH SYS_INIT	; set page
	MOVWF PCLATH
	GOTO SYS_INIT

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV
	MOVFW PCLATH
	MOVWF SYS_PSAV
	CLRF PCLATH

	BCF INTCON,T0IF	; Interrupt quitieren

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_0
	INCF MF1_HI,F

SYS_INT_LABEL_0
	INCFSZ MF2,F
	GOTO SYS_INT_LABEL_1
	INCF MF2_HI,F

SYS_INT_LABEL_1
	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_2
	INCF TR1_HI,F

SYS_INT_LABEL_2

EXITINT
	MOVFW SYS_PSAV
	MOVWF PCLATH

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************


EEINT_WRITE
	MOVFW INDF
	ADDWF SYS_TMP2,F
EEINT_WRITE_0
	BCF STATUS,RP0	; Bank 2
	BSF STATUS,RP1	; Bank 2
	MOVWF EEDATA
	BSF STATUS,RP0	; Bank 3
	BSF EECON1,WREN

EEINT_DISINT
	BCF INTCON,GIE
	BTFSC INTCON,GIE
	GOTO EEINT_DISINT

	MOVLW H'55'
	MOVWF EECON2
	MOVLW H'AA'
	MOVWF EECON2
	BSF EECON1,WR	; start write

	BSF INTCON,GIE

EEINT_WRITE_1
	CLRWDT
	BTFSC EECON1,WR	; ready ?
	GOTO EEINT_WRITE_1	; no
	BCF EECON1,WREN

	BCF STATUS,RP0	; Bank 2
	INCF EEADR,F
	INCF FSR,F
	DECFSZ SYS_TMP1,F
	GOTO EEINT_WRITE

	RETURN

;***************************************************

EEINT_READ
	BSF STATUS,RP0	; Bank 3
	BSF STATUS,RP1	; Bank 3
	BSF EECON1,RD
	BCF STATUS,RP0	; Bank 2
	MOVFW EEDATA
	MOVWF INDF
	INCF EEADR,F
	INCF FSR,F
	DECFSZ SYS_TMP1,F
	GOTO EEINT_READ
	RETURN

;***************************************************
; EE-Modul -> EE1
;***************************************************

WRITE_EE1
	BSF STATUS,RP0	; Bank 3
	BSF STATUS,RP1	; Bank 3
	BCF EECON1,EEPGD
	BCF STATUS,RP0	; Bank 2
	CLRF EEADRH
	MOVLW 0
	MOVWF EEADR
	INCF EEADR,F
	CLRF SYS_TMP2

	BCF STATUS,IRP	; vars - located in Bank 0
	MOVLW 8
	MOVWF SYS_TMP1
	MOVLW LOW DATA1
	MOVWF FSR

	CALL EEINT_WRITE

	MOVLW 0	; write checksum
	BCF STATUS,RP0	; Bank 2
	BSF STATUS,RP1	; Bank 2
	MOVWF EEADR
	INCF SYS_TMP1,F
	MOVLW LOW SYS_TMP2
	MOVWF FSR
	MOVFW INDF
	CALL EEINT_WRITE_0


	RETURN

;***************************************************
; EE-Modul -> EE1
;***************************************************

READ_EE1
	MOVLW 0
	BCF STATUS,RP0	; Bank 2
	BSF STATUS,RP1	; Bank 2
	MOVWF EEADR
	CLRF EEADRH
	BSF STATUS,RP0	; Bank 3
	BCF EECON1,EEPGD
	BCF STATUS,RP0	; Bank 2
	INCF EEADR,F	; test checksum
	CLRF SYS_TMP2
	MOVLW 8
	MOVWF SYS_TMP1

READ_EE1_0
	BSF STATUS,RP0	; Bank 3
	BSF EECON1,RD
	BCF STATUS,RP0	; Bank 2
	MOVFW EEDATA
	ADDWF SYS_TMP2,F
	INCF EEADR,F
	DECFSZ SYS_TMP1,F
	GOTO READ_EE1_0

	MOVLW 0
	MOVWF EEADR
	BSF STATUS,RP0	; Bank 3
	BSF EECON1,RD
	BCF STATUS,RP0	; Bank 2
	MOVFW EEDATA
	SUBWF SYS_TMP2,W
	BTFSS STATUS,ZERO
	RETURN	; Checksum error

	INCF EEADR,F

	BCF STATUS,IRP	; vars - located in Bank 0
	MOVLW 8
	MOVWF SYS_TMP1
	MOVLW LOW DATA1
	MOVWF FSR

	CALL EEINT_READ


	RETURN

;***************************************************
;***************************************************
; Subroutines for LB1
;***************************************************

LCD_LB1_INIT
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
LCD_LB1_L1
	CALL LCD_LB1_OUT4
	CLRWDT
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L1

	MOVFW PORTB
	ANDLW H'F0'
	IORLW B'0011'	; Function Set
	MOVWF PORTB

	BSF PORTB,5	; write
	BCF PORTB,5

	BSF SYS_TMP1,5	; wait
LCD_LB1_L2
	CALL LCD_LB1_OUT4
	CLRWDT
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L2

	BSF PORTB,5	; write
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	BSF PORTB,5	; write
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	BCF PORTB,0	; 4-Bit Interface

	BSF PORTB,5	; write
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	MOVLW B'00101000'	; Function Set 4-Bit,2-Lines
	CALL LCD_LB1_OUT

	MOVLW B'00001100'	; Display on, Cursor off, Blink off
	CALL LCD_LB1_OUT

	MOVLW B'00000110'	; Entrymode set
	CALL LCD_LB1_OUT

LCD_LB1_CLR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
	MOVLW B'00000001'	; Display clear
	CALL LCD_LB1_OUT

	BSF SYS_TMP1,5	; wait
LCD_LB1_L3
	CALL LCD_LB1_OUT4
	CLRWDT
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L3
	GOTO LCD_LB1_OUT4

;***************************************************

LCD_LB1_GOTOXY
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
	MOVLW H'40'
	BTFSC SYS_TMP2,0	; Ypos
	ADDWF SYS_TMP1,F
	MOVLW D'20'
	BTFSC SYS_TMP2,1	; Ypos
	ADDWF SYS_TMP1,F
	BSF SYS_TMP1,7	; select dd-ram
	GOTO LCD_LB1_OUT1

;***************************************************

LCD_LB1_WRITESTR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF PORTB,4	; dd-ram
LCD_LB1_WRITESTR1
	CALL LCD_LB1_CHAROUT
	BSF INTCON,GIE
	ANDLW H'FF'	; last is zero
	BTFSC STATUS,ZERO
	RETURN

	MOVWF SYS_TMP1
	MOVLW HIGH LCD_LB1_OUT1	; set page
	MOVWF PCLATH
	CLRWDT
	CALL LCD_LB1_OUT1
	INCFSZ SYS_TMP4,F	; next char
	GOTO LCD_LB1_WRITESTR1
	INCF SYS_TMP5,F	; next page
	GOTO LCD_LB1_WRITESTR1

LCD_LB1_CHAROUT
	BCF INTCON,GIE
	MOVFW SYS_TMP5
	MOVWF PCLATH
	MOVFW SYS_TMP4
	MOVWF PCL

;***************************************************

LCD_LB1_DEZO10000

	MOVLW LOW 10000
	MOVWF SYS_TMP1
	MOVLW HIGH 10000
	MOVWF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO1000
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO1000

	MOVLW LOW 1000
	MOVWF SYS_TMP1
	MOVLW HIGH 1000
	MOVWF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO100
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO100

	MOVLW LOW 100
	MOVWF SYS_TMP1
	CLRF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO10
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO10

	MOVLW LOW 10
	MOVWF SYS_TMP1
	CLRF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO1
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO1
	MOVLW 48
	ADDWF SYS_TMP4,W
	GOTO LCD_LB1_WRITECHAR

;***************************************************

LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	DECF SYS_TMP9,F
	CLRF SYS_TMP6
LCD_LB1_CONVERTDEZ2
	INCF SYS_TMP6,F

	MOVFW SYS_TMP1
	SUBWF SYS_TMP4,F

	MOVFW SYS_TMP2
	BTFSS STATUS,CARRY
	INCFSZ SYS_TMP2,W
	SUBWF SYS_TMP5,F
	BTFSC STATUS,CARRY
	GOTO LCD_LB1_CONVERTDEZ2

	MOVFW SYS_TMP2
	ADDWF SYS_TMP5,F
	MOVFW SYS_TMP1
	ADDWF SYS_TMP4,F
	BTFSC STATUS,CARRY
	INCF SYS_TMP5,F

	DECF SYS_TMP6,W
	BTFSS STATUS,ZERO
	BSF SYS_TMP10,0
	RETURN

;***************************************************

LCD_LB1_CONVERTHEX
	ANDLW 15
	MOVWF SYS_TMP1
	MOVLW 48
	ADDWF SYS_TMP1,F
	MOVLW 58
	SUBWF SYS_TMP1,W
	BTFSS STATUS,CARRY
	GOTO $+3
	MOVLW 7
	ADDWF SYS_TMP1,F
	MOVFW SYS_TMP1

;***************************************************

LCD_LB1_WRITECHAR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF PORTB,4	; dd-ram

;***************************************************

LCD_LB1_OUT
	MOVWF SYS_TMP1	; store
LCD_LB1_OUT1
	CLRF SYS_TMP3	; LCDWriteStr (first nibble)
LCD_LB1_OUT2
	SWAPF SYS_TMP1,W	;high nibble
LCD_LB1_OUT3
	ANDLW H'0F'	; mask
	MOVWF SYS_TMP2	; store
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW PORTB	; load port
	ANDLW H'F0'	; mask
	IORWF SYS_TMP2,W	; add cmd
	MOVWF PORTB	; out

	BSF PORTB,5	; E high
	BCF PORTB,5	; E low

	BTFSC SYS_TMP3,3	; ready ?
	GOTO LCD_LB1_OUT4	; yes
	BSF SYS_TMP3,3	; second nibble
	MOVFW SYS_TMP1
	GOTO LCD_LB1_OUT3	; next nibble

LCD_LB1_OUT4
LCD_LB1_OUTV
	DECFSZ SYS_TMP3,F
	GOTO LCD_LB1_OUTV
	RETURN

;***************************************************

LCD_LB1_CHECKNULL
	BTFSS STATUS,ZERO
	DECF SYS_TMP9,F
	MOVWF SYS_TMP1
	BTFSS STATUS,ZERO
	BSF SYS_TMP10,0
	MOVLW 48
	BTFSC SYS_TMP10,0
	ADDWF SYS_TMP1,f
	MOVLW 32
	BTFSS SYS_TMP10,0
	ADDWF SYS_TMP1,F
	MOVFW SYS_TMP1
	GOTO LCD_LB1_WRITECHAR
; 013B

;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW B'00000000'
	MOVWF PORTC

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG

	MOVLW 6	; all Digital
	MOVWF ADCON1

; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'11000000'
	MOVWF TRISB

	MOVLW B'11111111'
	MOVWF TRISC

; init vars


; Clear RAM

	BCF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR2
	BSF STATUS,IRP
	MOVLW 16
	MOVWF FSR
CR3
	CLRF INDF
	INCF FSR,F
	MOVLW H'70'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR3
	MOVLW 144
	MOVWF FSR
CR4
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR4



	CALL READ_EE1	; read vars from internal EE

;***************************************************
; Init LCD -> LB1
;***************************************************

	CALL LCD_LB1_INIT

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; Zhler -> ZR1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,5	; Reset ?
	GOTO LABEL_ZR1_COUNT
	CLRF ZR1
	GOTO LABEL_ZR1_SETOUT

LABEL_ZR1_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC ZR1_FD,0
	GOTO LABEL_ZR1_SETFD
	BTFSS PORTA,0
	GOTO LABEL_ZR1_SETFD

	INCF ZR1,F

LABEL_ZR1_SETOUT

; Output Q0

	BTFSS ZR1,0
	GOTO LABEL_ZR1_SETOUT0
	BSF S0,0
	GOTO LABEL_ZR1_SETOUT0_END
LABEL_ZR1_SETOUT0
	BCF S0,0
LABEL_ZR1_SETOUT0_END

LABEL_ZR1_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS PORTA,0
	GOTO LABEL_ZR1_SETFD2
	BSF ZR1_FD,0
	GOTO LABEL_ZR1_END
LABEL_ZR1_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF ZR1_FD,0
LABEL_ZR1_END

;***************************************************
; Abfall-Verzgerung -> MF1
;***************************************************

	BTFSS S0,0	; Eingang auf High ?
	GOTO LABEL_MF1_CHKTIME	; Nein

; RESET

	CLRF MF1
	CLRF MF1_HI
	BSF S0,2
	GOTO LABEL_MF1_EXIT	; raus

LABEL_MF1_CHKTIME

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,2	; Ausgang schon auf Low ?
	GOTO LABEL_MF1_EXIT	; Ja

	MOVLW 3
	SUBWF MF1_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	MOVLW 209
	SUBWF MF1,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	BCF S0,2
LABEL_MF1_EXIT

;***************************************************
; Mono-Flop -> MF2
;***************************************************

; Luft der Impuls ?

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC MF2_FD,1
	GOTO LABEL_MF2_CHKTIME

; Test auf negative Flanke

	BTFSS MF2_FD,0
	GOTO LABEL_MF2_SETFD
	BTFSC S0,0
	GOTO LABEL_MF2_SETFD


LABEL_MF2_RESET

	CLRF MF2
	CLRF MF2_HI
	BSF MF2_FD,1
	BSF S0,1

LABEL_MF2_CHKTIME

	MOVLW 0
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF MF2_HI,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MF2_CHECK
	MOVLW 39
	SUBWF MF2,W
LABEL_MF2_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_MF2_SETFD
LABEL_MF2_TO

	BCF MF2_FD,1
	BCF S0,1

LABEL_MF2_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,0
	GOTO LABEL_MF2_CLR
	BSF MF2_FD,0
	GOTO LABEL_MF2_ENDE
LABEL_MF2_CLR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF MF2_FD,0

LABEL_MF2_ENDE

;***************************************************
; EE-Modul -> EE1
;***************************************************


; Test of rising edge

	BTFSS S0,1
	GOTO LABEL_EE1_SETFD
	BTFSC EE1_FD,0
	GOTO LABEL_EE1_SETFD
	BSF EE1_FD,0

	MOVLW HIGH WRITE_EE1
	MOVWF PCLATH

	CALL WRITE_EE1
	MOVLW HIGH LABEL_EE1_SETFD
	MOVWF PCLATH

LABEL_EE1_SETFD

; test input

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S0,1
	GOTO LABEL_EE1_EXIT
	BCF EE1_FD,0

LABEL_EE1_EXIT

;***************************************************
; Zhler -> ZR2
;***************************************************

	BTFSS S0,6	; Reset ?
	GOTO LABEL_ZR2_COUNT
	CLRF ZR2
	GOTO LABEL_ZR2_SETOUT

LABEL_ZR2_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC ZR2_FD,0
	GOTO LABEL_ZR2_SETFD
	BTFSS S0,4
	GOTO LABEL_ZR2_SETFD

	INCF ZR2,F

LABEL_ZR2_SETOUT

LABEL_ZR2_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,4
	GOTO LABEL_ZR2_SETFD2
	BSF ZR2_FD,0
	GOTO LABEL_ZR2_END
LABEL_ZR2_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF ZR2_FD,0
LABEL_ZR2_END

;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BTFSS S0,2
	GOTO LABEL_LG1_FALSE
LABEL_LG1_2
	BTFSS S0,3
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BSF S0,4
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S0,4
LABEL_LG1_ENDE
;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 0	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 195
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 0	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 195
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S0,3
	GOTO LABEL_TR1_CLR
	BSF S0,3
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S0,3
LABEL_TR1_ENDE

;***************************************************
; LCD -> LT1
;***************************************************

; test of positiv edge

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC LT1_FD,0
	GOTO LABEL_LT1_SETFD
	BTFSS S0,4
	GOTO LABEL_LT1_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 0
	MOVWF SYS_TMP2

	MOVLW HIGH LCD_LB1_GOTOXY	; set page
	MOVWF PCLATH
	CALL LCD_LB1_GOTOXY

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW DATA1
	MOVWF SYS_TMP4
	MOVFW DATA1_HI
	MOVWF SYS_TMP5

	BSF SYS_TMP10,0
	MOVLW 1
	MOVWF SYS_TMP9
	MOVLW HIGH LCD_LB1_DEZO10000	; set page
	MOVWF PCLATH
	CALL LCD_LB1_DEZO10000
	BCF PCLATH,3	; Page 0
	BCF PCLATH,4	; Page 0
LABEL_LT1_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,4
	GOTO LABEL_LT1_SETFD2
	BSF LT1_FD,0
	GOTO LABEL_LT1_END
LABEL_LT1_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT1_FD,0
LABEL_LT1_END

;***************************************************
; LCD -> LT2
;***************************************************

; test of positiv edge

	BTFSC LT2_FD,0
	GOTO LABEL_LT2_SETFD
	BTFSS S0,4
	GOTO LABEL_LT2_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	MOVLW HIGH LCD_LB1_GOTOXY	; set page
	MOVWF PCLATH
	CALL LCD_LB1_GOTOXY

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW DATA2
	MOVWF SYS_TMP4
	MOVFW DATA2_HI
	MOVWF SYS_TMP5

	BSF SYS_TMP10,0
	MOVLW 3
	MOVWF SYS_TMP9
	MOVLW HIGH LCD_LB1_DEZO10000	; set page
	MOVWF PCLATH
	CALL LCD_LB1_DEZO10000
	BCF PCLATH,3	; Page 0
	BCF PCLATH,4	; Page 0
LABEL_LT2_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,4
	GOTO LABEL_LT2_SETFD2
	BSF LT2_FD,0
	GOTO LABEL_LT2_END
LABEL_LT2_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT2_FD,0
LABEL_LT2_END

;***************************************************
; LCD -> LT3
;***************************************************

; test of positiv edge

	BTFSC LT3_FD,0
	GOTO LABEL_LT3_SETFD
	BTFSS S0,4
	GOTO LABEL_LT3_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 3
	MOVWF SYS_TMP2

	MOVLW HIGH LCD_LB1_GOTOXY	; set page
	MOVWF PCLATH
	CALL LCD_LB1_GOTOXY

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW DATA3
	MOVWF SYS_TMP4
	MOVFW DATA3_HI
	MOVWF SYS_TMP5

	BSF SYS_TMP10,0
	MOVLW 1
	MOVWF SYS_TMP9
	MOVLW HIGH LCD_LB1_DEZO10000	; set page
	MOVWF PCLATH
	CALL LCD_LB1_DEZO10000
	BCF PCLATH,3	; Page 0
	BCF PCLATH,4	; Page 0
LABEL_LT3_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,4
	GOTO LABEL_LT3_SETFD2
	BSF LT3_FD,0
	GOTO LABEL_LT3_END
LABEL_LT3_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT3_FD,0
LABEL_LT3_END

;***************************************************
; LCD -> LT4
;***************************************************

; test of positiv edge

	BTFSC LT4_FD,0
	GOTO LABEL_LT4_SETFD
	BTFSS S0,4
	GOTO LABEL_LT4_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 2
	MOVWF SYS_TMP2

	MOVLW HIGH LCD_LB1_GOTOXY	; set page
	MOVWF PCLATH
	CALL LCD_LB1_GOTOXY

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW ZR2
	MOVWF SYS_TMP4
	CLRF SYS_TMP5

	BSF SYS_TMP10,0
	MOVLW 1
	MOVWF SYS_TMP9
	MOVLW HIGH LCD_LB1_DEZO100	; set page
	MOVWF PCLATH
	CALL LCD_LB1_DEZO100
	BCF PCLATH,3	; Page 0
	BCF PCLATH,4	; Page 0
LABEL_LT4_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,4
	GOTO LABEL_LT4_SETFD2
	BSF LT4_FD,0
	GOTO LABEL_LT4_END
LABEL_LT4_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT4_FD,0
LABEL_LT4_END

;***************************************************
;AF1
;***************************************************

	MOVFW DATA2_HI
	SUBWF DATA1_HI,W
	MOVWF DATA3_HI
	MOVFW DATA2
	SUBWF DATA1,W
	MOVWF DATA3
	BTFSS STATUS,CARRY
	DECF DATA3_HI,F

LABEL_AF1_EXIT
;***************************************************
; GND
;***************************************************

	BCF S0,5	; immer Low

;***************************************************
; GND
;***************************************************

	BCF S0,6	; immer Low

;****************************************

	GOTO MAIN









	ORG H'2100'

	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

	END

